//
//  NEXConnection.h
//  NumberEightCompiled
//
//  Created by Matthew Paletta on 2021-03-11.
//  Copyright © 2021 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEConnection.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents the connection state of peripherals.
 */
@interface NEXConnection : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param connection Value to copy from.
 */
- (instancetype)initWithConnection:(NEConnection)connection;

/**
 * Conversion copy constructor.
 * @param connection Value to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithConnection:(NEConnection)connection confidence:(double)confidence;

/**
 * @param state State to assume.
 */
- (instancetype)initWithState:(NEConnectionState)state;

/**
 * @param state State to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEConnectionState)state confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEConnection value DEPRECATED_ATTRIBUTE;

/**
 * Whether a peripheral is connected or disconnected.
 */
@property(nonatomic, readwrite) NEConnectionState state;

+ (NSString*)stringFromConnectionState:(NEConnectionState)state;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NEConnection_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEConnection)c_val;

@end
NS_ASSUME_NONNULL_END
